# Clock Generator [![status-badge](https://ci.onders.org/api/badges/finga/clock_generator/status.svg)](https://ci.onders.org/finga/clock_generator)

A simple board to control an Si5351 clock generator board with the
TWI. Though, this is not limited to the Si5351 board as it is designed
to be universal usable.

## Board
The board is populated with an ATmega328p, a display and its
backlight driver, a switchable rotary encoder and powered by a mini
USB port. All unneeded MCU pins are accessible via pin headers.

## Firmware
Currently there are two different firmwares. The older one which is
written in C and is not finished, and the newer one which is in an
early but functioning state and written in Rust.

### The Rust Firmware
To flash the firmware, connect the ICSP pins of the board to the
programmer and inside the `firmware/rust/` directory run `cargo make
all`. This burns the fuses, writes the the default values to the
eeprom and flashes the firmware.
